﻿/****************************************************************
Скрипт меняет регистр текста, помеченного сивольным или абзацным 
стилем, в соответствии с выбором пользователя в диалоговом окне.
Главная особенность скрипта - использование слов-исключений,
которые находятся в файле exceptions.txt.
Например, вам надо перевести текст, набранный в верхнем регистре,
в нижний регистр. Если выделить весь такой текст и воспользоваться
командой из меню Индизайна, то операция же конечно выполнится,
но переведутся в нижний регистр и те слова, которые должны оставаться
всегда в  верхнем регистре, такие как ГОСТ, КПСС, СССР, КГБ и т.п.
Если такие слова поместить в файл exceptions.txt и производить смену 
регистра данным скриптом, то смена регистра произойдет более
корректно, и слова, которые состоят только из заглавных букв,будут 
исключены из обработки.
Файл исключений должен находиться в той же папке, что и скрипт.
Зона действия скрипта - весь документ.
При отсутствии файла excеption.txt скрипт, получив ваше согласие, 
будет менять регистр у всего текста, помеченного символьным или 
абзацным стилем.

adobeindesign.ru
boriskasmoscow@gmail.com
    
****************************************************************/
//#target indesign
var myChStyleName;
var myParaStyleName;
var myCase; // сюда пишется в какой регистр произойдет перевод текста
var myStyleMode; //"режимная" переменная. Может принимать значения истины или лжи 
// Если она становится истиной, то пользователь выбрал режим работы с символьным стилем. Если ложью, то выбран для работы режим с абзацным стилем
var myWorkMode = true; // true - перевод регистра с исключениями, основной режим. False - перевод регистра без исключений
myExc = []; // массив слов-исключений. Заполняется чтением из файла исключений exceptions.txt. Этот файл формируется пользователем


main();

function main()
{
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
    if (app.documents.length != 0){
        var myDoc = app.documents.item(0);
        var myCharacterStylesList = myGetCharacterStyleNames();
        var myParagraphStylesList = myGetParagraphStyleNames();
        var myWin = myDialog(myCharacterStylesList, myParagraphStylesList);
        if (myWin.show() == 1) { 
            readFile();
            myChangeCase(myDoc);            
        }
    }
    else {
      alert("Нет открытых документов!");
      exit();
    }
    
} // main()

function myDialog(myChStList, myParaStList)
{
var myList0 = ["UPPERCASE","lowercase","Title Case"]; // для режима работы с символьным стилем. Здесь нет регистра Sentence Case, так как символьным стилем 
// целое предложение может быть и не выделено.
var myList1 = ["UPPERCASE","lowercase","Title Case", "Sentence case"]; // для работы скрипта с абзацным стилем. Как минимум одно целое предложение
// может быть в символьном стиле
var myFlag = true;    // предполагается символьный стиль по умолчанию
   // var myDg = new Window('dialog', "Change Case for Character or Paragraph Style");
    var myDg = new Window('dialog', "Смена регистра текста");    
    
	myDg.orientation = "column";
    myDg.alignChildren = "center";
    var myPnl = myDg.add("panel", undefined, '');
	myPnl.orientation = "column";
    myPnl.alignChildren = "right";
    
    var myRadioGroup = myPnl.add("group");
    myRadioGroup.orientation = "row";
    myRadioGroup.alignChildren = ["left", "top"];
    var myRadio1 = myRadioGroup.add('radiobutton', undefined, 'Символьный стиль');
    var myRadio2 = myRadioGroup.add('radiobutton', undefined, 'Абзацный стиль');
    myRadio1.value = true;
    
    myRadio2.onClick = function() {
        myGroup0.visible = false;
        myGroup1.visible = true;
        myFlag = false;
    }

    myRadio1.onClick = function() {
        myGroup0.visible = true;
        myGroup1.visible = false;
        //myList.pop();
        myFlag = true;
    }
 
    var mainGroup = myPnl.add("group");
    mainGroup.orientation = "stack"; // Stack - это главное!!! 
    mainGroup.alignChildren = "right";
    
    // первая группа, создаем и добавляем элементы
    var myGroup0 = mainGroup.add("group");
    myGroup0.orientation = 'column';
    myGroup0.alignChildren = "right";
    myGroup0.visible = true;
  
    var myDropdown0 = myGroup0.add("dropdownlist", undefined, myList0);
   // myDropdown0.title = 'Select Case'; 
    myDropdown0.title = 'В какой регистр перевести текст';    
    myDropdown0.minimumSize = [250,20];
    myDropdown0.enabled = true;
    myDropdown0.selection = 0;
    
    var myDropdown1 = myGroup0.add("dropdownlist", undefined, myChStList);
   // myDropdown1.title = 'Select Character Style'; 
    myDropdown1.title = 'Выберите символьный стиль';     
    myDropdown1.minimumSize = [250,20];
    myDropdown1.enabled = true;
    myDropdown1.selection = 0;
    
  // вторая группа, создаем и добавляем элементы
    var myGroup1 = mainGroup.add("group");
    myGroup1.orientation = 'column';
    myGroup1.visible = false; 
    myGroup1.alignChildren = "right";
 
    var myDropdown2 = myGroup1.add("dropdownlist", undefined, myList1);
   // myDropdown2.title = 'Select Case'; 
    myDropdown2.title = 'В какой регистр перевести текст';     
    myDropdown2.minimumSize = [250,20];
    myDropdown2.enabled = true;
    myDropdown2.selection = 0;
    
    var myDropdown3 = myGroup1.add("dropdownlist", undefined, myParaStList);
  //  myDropdown3.title = 'Select Paragraph Style'; 
    myDropdown3.title = 'Выберите абзацный стиль';     
    myDropdown2.minimumSize = [250,20];
    myDropdown2.enabled = true;
    myDropdown3.selection = 0;
 
    
    // add buttons    
    var myButtonGroup = myDg.add( "group" );
    var OKButton = myButtonGroup.add( "button", undefined, "OK" );
    OKButton.enabled = true;
    OKButton.helpTip = "This is start button";
    OKButton.onClick = function()
    {
            if(myFlag) {
                myCase = myDropdown0.selection.text;
                myChStyleName = myDropdown1.selection.text;
            }
            else {
                myCase = myDropdown2.selection.text;
                myParaStyleName = myDropdown3.selection.text;
            }
        myStyleMode = myFlag;
        myDg = this.window.close( 1 );
    }
    
    var myCancelButton = myButtonGroup.add( "button", undefined, "Cancel" );
    myCancelButton.onClick = function() { myDg = this.window.close( 0 ); }
    
    return myDg;
}

function readFile()
{
// пытаемся считать данные из ф-ла исключений. Если файла нет или он поврежден, всё равно можем продолжить работу

  // var f = File(app.activeScript.parent + "/exceptions.txt"); // << этот вариант в отладчике не работает
  
var myScriptFile = myGetScriptPath();
var iniFileInfo  = "exceptions.txt";
var myScriptFolder = decodeURI(myScriptFile.path);
var filePath = decodeURI(myScriptFolder + "/" + iniFileInfo); 
var f = new File (filePath);
5
   if (f.exists) {
        try {
            f.open('r')
            myExc = f.read().split('\n');            
        }
        catch(errOpen) {
            if ( confirm("Ошибка открытия файла исключений. Продолжаем без данных этого файла?")) {
            myWorkMode = false;
            return;
            }
            else { 
                alert("Что-то пошло не так. [1]"); // <<< это я добавил. Просто exit() быть не должно.
                exit(); 
                }
        }
        
    } // if
    else {
        if( confirm("Файл исключений не найден. Продолжаем без исключений из этого файла?") ) {
            myWorkMode = false;
            return;
        }
        else { 
            alert("Что-то пошло не так. [2]"); // <<< это я добавил. Просто exit() быть не должно.
            exit(); 
            }
        
    } // else

} // readFile fnc
/*****************************************************/
function myFile(myFileName) { // myFile
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" +myFileName);
return myFilePath;
} //myFile
function myGetScriptPath() { // myGetScriptPath()
	try{
		return app.activeScript;
	}
	catch(myError){
		return File(myError.fileName);
	}
} //myGetScriptPath()
//////////////////
function myChangeCase(myDoc)
{

app.findGrepPreferences = app.changeGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeFootnotes = false;
app.findChangeGrepOptions.includeHiddenLayers = false;
app.findChangeGrepOptions.includeLockedLayersForFind = false;
app.findChangeGrepOptions.includeLockedStoriesForFind = false;
app.findChangeGrepOptions.includeMasterPages = false;

if(myStyleMode) { // работаем по символьному стилю, ищем слова.
    var myChStyle = getCharacterStyleByName( myChStyleName );
    app.findGrepPreferences.appliedCharacterStyle = myChStyle;
    app.findGrepPreferences.findWhat ='\\w+';
}
else  { // работаем по абзацному стилю, Ищем предложения. Их потом подвергаем смене регистра
  
    var myPaStyle = getParagraphStyleByName( myParaStyleName );
    app.findGrepPreferences.appliedParagraphStyle = myPaStyle;
    app.findGrepPreferences.findWhat = "[^ .!?][^.!?]+";
}

// поиск!
var foundText = myDoc.findGrep();
if(foundText.length == 0) {
    alert("Текст для преобразования не найден. Попробуйте еще раз");
    exit();
}

   for(var i=0; i< foundText.length; i++) {
       if(myStyleMode) { // работаем по символьному стилю
           if(myWorkMode) { // используется файл исключений
                foundText[i].contents = reallyChangeCase0(foundText[i].contents);
                }
            else
            { // нет файла исключений
                foundText[i] = reallyChangeCase3(foundText[i]);
            }
        }
        else { //работаем по стилю абзаца
            if(myWorkMode) { // используется файл исключений
                
                foundText[i].contents = reallyChangeCase2(foundText[i].contents);
            }
            else { // нет файла исключений
                foundText[i] = reallyChangeCase3(foundText[i]);
            }
      } // else
    }// for
	

} // fnc
// 0000000000000000000000000000000000000000000000000
function reallyChangeCase0(myWord)
{
 // работаем по символьному стилю. файл исключений используется

    switch(myCase)
    {
        case "UPPERCASE":              
                if(!inArray(myWord)) {
                    myWord = myWord.toUpperCase();                    
                }//if            
        break;
        
        case "lowercase":             
                if(!inArray(myWord)) {
                    myWord = myWord.toLowerCase();                   
                }//if            
        break;
        
        case "Title Case":              
                if(!inArray(myWord)) {
                    //myWord = myWord.charAt(0).toUpperCase() + myWord.substr(1).toLowerCase();
                    myWord = wordToTitleCase(myWord);
                }//if            
        break;

        default :  alert('error: undefined dropdown choice');      
        break; 
    }// switch

return myWord;
    
} // fnc
// 11111111111111111111111111111111111111111111111111
function reallyChangeCase1(myWord) // нет файла исключений
{
    switch(myCase) 
        {
            case "UPPERCASE":   myWord = myWord.toUpperCase();  break;
            case "lowercase":      myWord = myWord.toLowerCase();  break;
            case "Title Case":      myWord = myWord.toTitleCase();    break;
            //case "Title Case":      myWord = myWord.charAt(0).toUpperCase() + myWord.substr(1).toLowerCase();    break;
            default :  alert('error: undefined dropdown choice');         break;    
        } //switch   
 return myWord;   
} // fnc

// 2222222222222222222222222222222222222
// По стилю абзаца, файл исключений найден
function reallyChangeCase2(foundText)
{
    var myW;
    var myWords = foundText.split(/(\s+)/);
    //var myWords = foundText.match(/\w+|"[^"]+"/g);

    for(var i =0; i<myWords.length; i++)
    {
            myW = myWords[i];
            myW = myW.replace(/[^A-Za-zА-Яа-яЁё]/g, "");

                switch(myCase)
                {
                    case "UPPERCASE":              
                            if(!inArray(myW)) {
                                myWords[i] = myWords[i].toUpperCase();                    
                            }//if            
                    break;
                    
                    case "lowercase":             
                            if(!inArray(myW)) {
                                myWords[i] = myWords[i].toLowerCase();                   
                            }//if            
                    break;
                    
                    case "Title Case":              
                            if(!inArray(myW)) {
                                //myWords[i] = myWords[i].charAt(0).toUpperCase() + myWords[i].substr(1).toLowerCase(); 
                                myWords[i] = wordToTitleCase(myWords[i]);
                            }//if            
                    break;
                    case "Sentence case":
                            if(!inArray(myW)) {
                                if(!i) {
                                // myWords[i] = myWords[i].charAt(0).toUpperCase() + myWords[i].substr(1).toLowerCase();
                                //myWords[i] = myWords[i].toTitleCase();
                                myWords[i] = wordToTitleCase(myWords[i]);
                                }
                                else {
                                    myWords[i] = myWords[i].toLowerCase(); 
                                }
                            } // if
                    break;
                    default :  alert('error: undefined dropdown choice');      
                    break; 
                }// switch
    } // for
    return myWords.join('');
}

// 333333333333333333333333333333333333
function reallyChangeCase3(myObj)
{
    switch(myCase)
    {
        case "UPPERCASE":
            myObj.changecase(ChangecaseMode.UPPERCASE); break;
        case "lowercase":
            myObj.changecase(ChangecaseMode.LOWERCASE); break;
        case "Title Case":
            myObj.changecase(ChangecaseMode.TITLECASE); break;
        case "Sentence case" :
            myObj.changecase(ChangecaseMode.SENTENCECASE); break;
        
        default :  alert('error: undefined dropdown choice');    
            break;  
    }// switch

} // fnc

function myGetCharacterStyleNames()
// Получаем список символьных стилей
{
	var curGroup;
	var curGroupName;
	var curNameInGroup;
	var myCharacterStyleNames = app.activeDocument.characterStyles.everyItem().name;
	myCharacterStyleNames.shift(); // удаление стиля None
	var charGroups = app.activeDocument.characterStyleGroups;
	var charStyleGroupLen = charGroups.length;
	for(var i=0; i < charStyleGroupLen; i++)
	{
		curGroup = charGroups[i];
		curGroupName = charGroups[i].name;
		curGroupStyleNames = curGroup.characterStyles.everyItem().name;
		for (j=0; j< curGroupStyleNames.length; j++)
		{
			curNameInGroup = curGroupName +":"+ curGroupStyleNames[j];
			myCharacterStyleNames.push(curNameInGroup);
		}
	} //for
	return myCharacterStyleNames;
}


function getCharacterStyleByName(myStyleName)
{
	var DocChStyles = app.activeDocument.characterStyles;
	var DocCharGroups = app.activeDocument.characterStyleGroups;
	// Есть ли в имени полученного символьного стиля двоеточие? (двоеточие разделяет название группы стилей и название стиля)
	myStyleName = String (myStyleName);
	var pos = myStyleName.indexOf(":")
	if(pos == -1)
	{
	// стиль не в группе
		return DocChStyles.item(myStyleName)
	} //if...
	else
	{// Стиль в какой-то группе
		var myGroupAndStyleNames = myStyleName.split(":")
		var myGroupName = myGroupAndStyleNames[0];
		var myStyleName = myGroupAndStyleNames[1];
		var myGroup = DocCharGroups.item(myGroupName);
		return myGroup.characterStyles.itemByName(myStyleName);				
	} // else
} // fnc()

function inArray(value)
{
	var res = false;
    //value = value.replace(/[^A-Za-zА-Яа-яЁё]/g, "");
	for (i = 0; i < myExc.length; i ++){
        if (myExc[i] == value){
			res = true;
			break;
		}
	}
	return res;
} // end of fnc



function myGetParagraphStyleNames()
{
var result = [];    
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
for(var i=0; i < myParagraphStyles.length ; i++)
{
    myParagraphStyleName = myParagraphStyles[i].name;
    obj = myParagraphStyles[i];
    while(obj.parent instanceof ParagraphStyleGroup)
    {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
    }
    result.push(myParagraphStyleName);
 } // for
result.shift(); // удаление стиля No Paragraph Style
return result;
} // fnc

function getParagraphStyleByName(myStyleName)
{
var myParagraphStyles = app.activeDocument.allParagraphStyles;
var myParagraphStyleName, obj;
    for(var i=0; i < myParagraphStyles.length ; i++)
    {
        myParagraphStyleName = myParagraphStyles[i].name;
        obj = myParagraphStyles[i];
        while(obj.parent instanceof ParagraphStyleGroup)
        {
            myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
            obj = obj.parent;        
        }
        if(myParagraphStyleName == myStyleName)  return myParagraphStyles[i];
     } // for
    
} // fnc


function wordToTitleCase(mystr)
{
var j=0;
var StartStr;
mystr = mystr.toLowerCase();
while (mystr.charAt(j) =='(' || mystr.charAt(j) == '\"' || mystr.charAt(j) == '[' || mystr.charAt(j) == '«' || mystr.charAt(j) == '{' )
{ j++}
startStr = mystr.substring(0, j);
mystr = startStr + mystr.charAt(j).toUpperCase() +mystr.substr(j+1).toLowerCase(); 
return mystr;
} // fnc*/